--- /home/eptegom/p/otpr15bainst/linux/lib/observer-1.0/src/observer_lib.erl	2011-12-14 13:01:23.000000000 +0100
+++ observer_lib.erl	2012-01-22 11:47:06.760698686 +0100
@@ -341,15 +341,20 @@
 	    wxTextEntryDialog:destroy(Dialog),
 	    parse_string(Str);
 	?wxID_CANCEL ->
-	    wxTextEntryDialog:destroy(Dialog)
+	    wxTextEntryDialog:destroy(Dialog),
+	    cancel
     end.
 
 parse_string(Str) ->
     try
-	{ok, Tokens, _} = erl_scan:string(Str),
-	erl_parse:parse_term(Tokens)
-    catch _:{badmatch, {error, {_, _, Err}}} ->
-	    {error, ["Parse error: ", Err]};
+	StrDot = case lists:last(Str) of
+		     $.  -> Str;
+		     _ -> Str ++ "."
+		 end,
+	{ok, Tokens, _} = erl_scan:string(StrDot),
+	{ok, _} = erl_parse:parse_term(Tokens)
+    catch _:{badmatch, {error, {_, Mod, Err}}} ->
+	    {error, lists:flatten(["Parse error: ", Mod:format_error(Err)])};
 	  _Err ->
 	    {error, ["Syntax error in: ", Str]}
     end.
